﻿using System;
using System.IO;

namespace NTERA.Compiler
{
	class Program
	{
		static void Main(string[] args)
		{
			string path = args.Length > 0
				? Path.GetFullPath(args[0])
				: Environment.CurrentDirectory;

			string outputPath = Path.Combine(path, "output");

			if (!Directory.Exists(outputPath))
				Directory.CreateDirectory(outputPath);

			Console.WriteLine("NTERA 0.X");
			Console.WriteLine("-------------------------");
			Console.WriteLine($"Compiling '{path}' to '{outputPath}'");
			Console.WriteLine("Using 8 threads");
			


			Compiler compiler = new Compiler(path);
			compiler.Compile(outputPath);

			Console.WriteLine();
			Console.WriteLine($"{compiler.DeclaredFunctions.Count} total functions");
			Console.WriteLine($"{compiler.Errors.Count} errors");
			Console.WriteLine("Report written");
		}
	}
}